
		csetdata_0			;64 bytes charset for line 0

		;generate an empty screen
cset_clear:	cli
		ldi	YH,HIGH(zx_ram+0x7d)	;video mem
		ldi	YL,LOW(zx_ram+0x7d)
		ldi	r16,0x76		;halt
		st	Y+,r16
		ldi	XH,24
cset_vclear_1:	ldi	XL,32
cset_vclear_2:	st	Y+,r19
		dec	XL
		brne	cset_vclear_2
		st	Y+,r16
		dec	XH
		brne	cset_vclear_1
		ldi	XL,0x7d
		ldi	XH,0x40
		sts	zx_ram+0x0c,XL
		sts	zx_ram+0x0d,XH
		ldi	XL,0xc0			;slow
		sts	zx_ram+0x3b,XL
		sei
		ret

		csetdata_1			;64 bytes charset for line 0 inverted

		;write char r19 (X=coords)
cset_char:	ldi	YL,0x7e
		ldi	YH,HIGH(zx_ram)
		ldi	r16,33
		andi	XH,0x1f
		mul	r16,XH
		add	YL,r0
		adc	YH,r1
		andi	XL,0x1f
		add	YL,XL
		adc	YH,const_0
		st	Y,r19
		inc	XL
		cpi	XL,32
		brcc	cset_char_0
		ret
cset_char_0:	clr	XL
cset_char_1:	ret

		csetdata_2			;64 bytes charset for line 1

		;write a bit 6 terminated string from flash to screen
cset_flashtext:	lpm	r19,Z+
		sbrc	r19,6
		ret
		rcall	cset_char			;write to screen
		rjmp	cset_flashtext


		csetdata_3			;64 bytes charset for line 1 inverted

		;write a bit 7 terminated string from ram to screen
cset_ramtext:	ld	r19,Z
		andi	r19,0x3f
		rcall	cset_char			;write to screen
		ld	r19,Z+
		sbrc	r19,7
		ret
		rjmp	cset_ramtext


		csetdata_4			;64 bytes charset for line 2

		;write a big char to screen, r20=char
cset_bigchar:	ldi	ZH,HIGH(libmio_ctable*2)
		mov	ZL,r20
		andi	ZL,0xbf			;limit to 0..63 / 128..191
		ldi	r21,8			;lines
cset_bchar_1:	lpm	r23,Z			;get pixline
		com	r23
		ldi	r22,8			;8 pix
cset_bchar_2:	clr	r19
		lsl	r23
		ror	r19
		rcall	cset_char
		dec	r22
		brne	cset_bchar_2
		inc	ZH			;next pixline
		subi	XL,8
		inc	XH
		dec	r21
		brne	cset_bchar_1
		subi	XH,8
		subi	XL,0xf8
		ret

		csetdata_5			;64 bytes charset for line 2 inverted

cset_intro:	ldi	r19,0x08
		rcall	cset_clear		;clear screen
		ldi	XL,0
		ldi	XH,4
		ldi	r20,38+128		;'A'
		rcall	cset_bigchar		;clear screen
		ldi	r20,61+128		;'X'
		rcall	cset_bigchar		;clear screen
		ldi	r20,0x24		;'8'
		rcall	cset_bigchar		;clear screen
		ldi	r20,0x1d		;'1'
		rcall	cset_bigchar		;clear screen

		ldi	XL,5
		ldi	XH,13
		ldi	ZL,LOW(intro_text*2)
		ldi	ZH,HIGH(intro_text*2)
		rcall	cset_flashtext

		ldi	XL,12
		ldi	XH,15
		ldi	ZL,LOW(intro_text*2+24)
		ldi	ZH,HIGH(intro_text*2+24)
		lds	r19,fileio_ram+36
		sbrs	r19,0
		adiw	ZL,8
		rcall	cset_flashtext
		rjmp	cset_intro2

		csetdata_6			;64 bytes charset for line 3

cset_intro2:	sts	libmio_nmi,const_1
		sts	libmio_keycode,const_0
		ldi	XL,240
.if USE_BL == 1
		in	r20,BIPORT
.endif
		sts	zx_ram+0x34,XL
		sts	zx_ram+0x35,const_0
introloop:	lds	XL,libmio_keycode
		cpi	XL,0x00
		brne	introloop_exit
.if USE_BL == 1
		in	r21,BIPORT
		eor	r21,r20
		sbrc	r21,BIPIN
		jmp	bl_init
.endif
		lds	XL,zx_ram+0x34
		cpi	XL,0x00
		brne	introloop
introloop_exit:	ret

introloop_fsys:	ret

		csetdata_7			;64 bytes charset for line 3 inverted

intro_text:	.db	0x08,0x00,0x3b,0x1c,0x1b,0x1e,0x1d,0x00
		.db	0x10,0x28,0x11,0x00,0x2f,0x1b
		.db	0x3c,0x34,0x31,0x2b,0x37,0x26,0x32,0x00
		.db	0x08,0xff

		.db	0x08,0x13,0x28,0x26,0x37,0x29,0x12,0xff		;card
		.db	0x33,0x34,0x00,0x28,0x26,0x37,0x29,0xff		;no card

		csetdata_8			;64 bytes charset for line 4

fsys_check:	lds	XL,fileio_ram+36
		sbrc	XL,0
		ret
		ldi	XL,T_ERR
		sts	0x200,XL		;error
		pop	r0			;killlast stack entry
		pop	r0
		ret				;file not found

;------------------------------------------------------------------------------
; LLIST init (ED12)
;------------------------------------------------------------------------------
fsys_lli:	sts	fileio_ram+33,const_0		;file
		sts	fileio_ram+34,const_0		;char
		clr	r16
		lds	r0,fileio_ram+32		;tape number
		call	fsys_rname			;read name
		ret

;------------------------------------------------------------------------------
; LLIST nextfile (ED13)
;------------------------------------------------------------------------------
fsys_nli:	sts	fileio_ram+34,const_0		;char
		lds	r16,fileio_ram+33		;next file
		inc	r16
		sts	fileio_ram+33,r16
		call	fsys_rname			;read name
		ret

		csetdata_9			;64 bytes charset for line 4 inverted

;------------------------------------------------------------------------------
; save a file
;------------------------------------------------------------------------------
fsys_save:	rcall	fsys_check

		ldi	YL,LOW(fileio_ram)	;filename from request
		ldi	YH,HIGH(fileio_ram)
		ldi	r16,10
fsys_save_1:	st	Y+,const_0		;space
		dec	r16
		brne	fsys_save_1
		lds	ZL,0x214		;4014 in ZX RAM
		lds	ZH,0x215		;4015 in ZX RAM
		subi	ZL,0x09
		sbci	ZH,0x40
		adiw	ZL,1			;store incl
		st	Y+,ZL
		st	Y+,ZH

fsys_save_2:	mov	ZH,reg_h
		mov	ZL,reg_l
		andi	ZH,0x3f			;limit to 16K
		subi	ZH,0xfe			;sys offset
		ldi	YL,LOW(fileio_ram)	;filename from request
		ldi	YH,HIGH(fileio_ram)
		ld	r16,Z
		cpi	r16,0x16		;"-"
		breq	fsys_delx_1
		ldi	r16,10
		rjmp	fsys_save_3
fsys_delx_1:	rjmp	fsys_delete_1

		csetdata_a			;64 bytes charset for line 5

fsys_save_3:	ld	r17,Z+			;name char
		mov	r0,r17
		andi	r17,0x3f
		st	Y+,r17
		sbrc	r0,7
		rjmp	fsys_save_4
		dec	r16
		brne	fsys_save_3
fsys_save_4:	jmp	fsys_wfile

fsys_delete_1:	adiw	ZL,1
		ld	r16,Z+			;char 1
		andi	r16,0x3f
		cpi	r16,0x26
		breq	fsys_del5x
		subi	r16,0x1c
		ldi	r17,10
		mul	r16,r17
		ld	r17,Z+			;char 2
		andi	r17,0x3f
		subi	r17,0x1c
		add	r17,r0
		cpi	r17,0x20
		brcc	fsys_delex
		sts	fileio_ram+33,r17	;file number
		jmp	fsys_dfile
fsys_del5x:	rjmp	fsys_delete_5
fsys_delex:	rjmp	fsys_delete_e

		csetdata_b			;64 bytes charset for line 5 inverted

fsys_delete_e:	ldi	XL,T_ERR
		sts	0x200,XL
fsys_delete_x:	ret

fsys_delete_5:	ld	r16,Z+			;char 2
		andi	r16,0x3f
		cpi	r16,0x31
		brne	fsys_delete_e

		ld	r16,Z+			;char 3
		andi	r16,0x3f
		cpi	r16,0x31
		brne	fsys_delete_e

		sts	fileio_ram+33,const_0	;file number
fsys_delete_6:	call	fsys_dfile
		lds	r16,fileio_ram+33	;get file number
		inc	r16
		cpi	r16,0x20
		brcc	fsys_delete_x
		sts	fileio_ram+33,r16
		rjmp	fsys_delete_6

		csetdata_c			;64 bytes charset for line 6

;------------------------------------------------------------------------------
; load a file
;------------------------------------------------------------------------------
fsys_load:	rcall	fsys_check

		ldi	YL,LOW(fileio_ram)	;filename from request
		ldi	YH,HIGH(fileio_ram)
		ldi	r16,10
fsys_load_1:	st	Y+,const_0		;space
		dec	r16
		brne	fsys_load_1

fsys_load_2:	mov	ZH,reg_h
		mov	ZL,reg_l
		sbrc	ZH,7
		rjmp	fsys_load_5		; LOAD "" is ignored
		andi	ZH,0x3f
		subi	ZH,0xfe
		ldi	YL,LOW(fileio_ram)	;filename from request
		ldi	YH,HIGH(fileio_ram)
		ldi	r16,10
fsys_load_3:	ld	r17,Z+			;name char
		mov	r0,r17
		andi	r17,0x3f
		cpi	r17,0x0d		;"$"
		breq	fsys_load6x		;direct load
		st	Y+,r17
		sbrc	r0,7
		rjmp	fsys_load_4
		dec	r16
		brne	fsys_load_3
fsys_load_4:	jmp	fsys_rfile
fsys_load_5:	ret
fsys_load6x:	rjmp	fsys_load_6

		csetdata_d			;64 bytes charset for line 6 inverted

fsys_load_6:	ld	r16,Z+
		sbrc	r16,7
		rjmp	fsys_delete_e		;only 1 digit
		subi	r16,0x1c
		ldi	r17,10
		mul	r16,r17
		ld	r17,Z+			;char 2
		sbrs	r17,7
fsys_load_7:	rjmp	fsys_delete_e		;more than 2 digits
		andi	r17,0x3f
		subi	r17,0x1c
		add	r17,r0
		cpi	r17,0x20
		brcc	fsys_load_7
		mov	r16,r17
		mov	ZL,r17
		sts	fileio_ram+33,ZL
		call	fsys_rname
		lds	r0,fileio_ram+16
		sbrs	r0,7
		jmp	fsys_rfile_02		;load direct
		rjmp	fsys_delete_e		;error

		csetdata_e			;64 bytes charset for line 7

;------------------------------------------------------------------------------
; LLIST char(ED14)
;------------------------------------------------------------------------------
fsys_lchar:	lds	r16,fileio_ram+34		;char no

fsys_lchar_01:	cpi	r16,2
		brcc	fsys_lchar_10
		mov	r17,r16
		lds	r16,fileio_ram+33		;file
		ldi	reg_a,0x9c			;invers "0"
fsys_lchar_02:	subi	r16,10
		brcs	fsys_lchar_03
		inc	reg_a
		rjmp	fsys_lchar_02
fsys_lchar_03:	subi	r16,0x5a			;+10+128
		sbrc	r17,0
		mov	reg_a,r16
fsys_lchar_nxt:	lds	r16,fileio_ram+34		;char no
		inc	r16
		sts	fileio_ram+34,r16		;next position
		ret

fsys_lchar_10:	cpi	r16,12
		brcc	fsys_lchar_s			;force space
		lds	r17,fileio_ram+36
		ldi	reg_a,0x16			;"-"
		sbrs	r17,0
		rjmp	fsys_lchar_nxt
		rjmp	fsys_lchar_1

		csetdata_f			;64 bytes charset for line 7 inverted

fsys_lchar_1:	ldi	YL,LOW(fileio_ram+14)
		ldi	YH,HIGH(fileio_ram+14)
		add	YL,r16
		adc	YH,const_0
		ld	r16,Y				;get char
		st	Y,const_1
		cpi	r16,0x40
		brcc	fsys_lchar_s			;force space
		mov	reg_a,r16
		rjmp	fsys_lchar_nxt

fsys_lchar_s:	clr	reg_a
		rjmp	fsys_lchar_nxt



